SystemOrganization addCategory: #'tODE-Inspector'!

TOView subclass: #TOInspector
	instanceVariableNames: 'basicInspect toggleVisible basicMembers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
basicFieldsFor: anObject

	(Pragma allNamed: #tODEBasicInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 09:28'!
basicInspect

	^basicInspect! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:47'!
basicMembers

	^basicMembers! !

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
fieldsFor: anObject

	(Pragma allNamed: #tODEInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 09:25'!
getMembers
	| members |
	basicMembers := toggleVisible := true.
	basicInspect
		ifTrue: [ members := self basicFieldsFor: self object ]
		ifFalse: [ 
			members := self fieldsFor: self object.
			members isEmpty
				ifTrue: [ 
					members := self basicFieldsFor: self object.
					toggleVisible := false ]
				ifFalse: [ basicMembers := false ] ].
	^ members! !

!TOInspector methodsFor: 'initialize-release' stamp: 'dkh 5/23/2011 09:25'!
initialize

	super initialize.
	basicInspect := toggleVisible := basicMembers := false.! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:14'!
renderBasicMembers: members on: html main: main
	members
		do: [ :fieldSpec | 
			fieldSpec hasKey
				ifTrue: [ 
					self
						renderLink: [ :s | 
							main currentSpace push: fieldSpec key selecting: fieldSpec keySelectedTab.
							main updateCenterSideHistory: s ]
						with: fieldSpec keyLabel
						on: html.
					html text: ' -> ' ]
				ifFalse: [ fieldSpec keyLabel ifNotNil: [ html text: fieldSpec keyLabel , ' -> ' ] ].
			fieldSpec hasValue
				ifTrue: [ 
					self
						renderLink: [ :s | 
							main currentSpace push: fieldSpec value selecting: fieldSpec valueSelectedTab.
							main updateCenterSideHistory: s ]
						with: fieldSpec valueLabel
						on: html ]
				ifFalse: [ html preformatted: fieldSpec valueLabel ].
			html break ]! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:44'!
renderBasicToggleOn: html main: main
	toggleVisible
		ifTrue: [ 
			self
				renderButton: [ :s | 
					basicInspect := basicInspect not.
					main updateCenterOn: s ]
				label:
					(basicInspect
						ifTrue: [ 'standard inspector' ]
						ifFalse: [ 'basic inspector' ])
				on: html.
			html break ]! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 09:23'!
renderContentOn: html main: main
	self object renderInspectorContentOn: html for: self main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/28/2011 11:28'!
renderExtraInspectorContentOn: html main: main

	(Pragma allNamed: #tODEInspectorExtraRendering from: self object class to: nil) do: [:pragma |
		^self object perform: pragma method selector withArguments:  {html. main}].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:22'!
renderMembers: members on: html main: main
	self
		renderBasicMembers:
			{((TOInspectorKeylessFieldSpec new)
				keyLabel: 'self';
				value: self object)}
		on: html
		main: main.
	html horizontalRule .
	basicMembers
		ifFalse: [ self renderExtraInspectorContentOn: html main: main ].
	self renderBasicMembers: members on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:08'!
renderMembersOn: html main: main
	self renderMembers: self getMembers on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 09:23'!
renderStandardContentOn: html main: main
	| members classText actualClass |
	members := self getMembers.
	actualClass := self actualClass.
	classText := self object isBehavior
		ifTrue: [ 'the Class ' , actualClass name ]
		ifFalse: [ 'an instance of ' , actualClass name ].
	(html heading)
		level: 3;
		with:
				(basicMembers
						ifTrue: [ 'Basic Inspector on ' , classText ]
						ifFalse: [ 'Inspector on ' , classText ]).
	self renderBasicToggleOn: html main: main.
	html break.
	self renderMembers: members on: html main: main! !

!Dictionary methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:12'!
tODEInspectorFields
	<tODEInspectorFields>
	^ self associations
		collect: [ :assoc | 
			(TOInspectorFieldSpec new)
				key: assoc key;
				value: assoc value ]! !

!Association methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:52'!
asKeylessFieldSpec
	^ (TOInspectorKeylessFieldSpec new)
		keyLabel: key;
		value: value! !

!String methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 11:47'!
renderExtraContentOn: html tODEMain: main
	<tODEInspectorExtraRendering>
	"no extra fields"! !

!String methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:37'!
tODEInspectorFields
	<tODEInspectorFields>
	^ {TOInspectorValuelessFieldSpec new valueLabel: self}! !

!TOObjectFrame methodsFor: '*tode-inspector' stamp: 'dkh 5/30/2011 15:43'!
frameTabSpec
	<tODEFrameTabSpec>
	
	^ (TOTabSpec new)
		id: #tODE;
		renderer: self;
		receiver: self;
		frame: self;
		label: 'tODE';
		order: 50;
		group: 'tODE';
		renderSelector: #renderFrameTabOn:spec:tOdeMain:! !

!TOObjectFrame methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 11:06'!
renderFrameTabOn: html spec: aTOSpecTab tOdeMain: main
	| members inspector |
	inspector := TOInspector new.
	html
		break;
		strong: self label;
		text: ' for ' , self historyLabel;
		break;
		break.
	inspector
		renderBasicMembers:
			({('root' -> TORoot current).
			('frame' -> self).
			('object' -> self object).
			('main' -> main)} collect: [ :each | each asKeylessFieldSpec ])
		on: html
		main: main.
	html break.
	html strong: 'frame properties:'.
	members := (self properties associations sorted: [:a :b | a key <= b key ]) collect: [ :each | each asKeylessFieldSpec ].
	html unorderedList: [ inspector renderBasicMembers: members on: html main: main ]! !

!MethodReference methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 11:22'!
renderInspectorContentOn: html for: aTOInspector main: main
	aTOInspector getMembers.
	aTOInspector basicInspect
		ifTrue: [ ^ aTOInspector renderStandardContentOn: html main: main ].
	aTOInspector renderBasicToggleOn: html main: main.
	html horizontalRule.
	aTOInspector
		renderLink: [ :s | 
			main currentSpace push: self methodClass selecting: #classBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: self methodClass name]
		on: html.
	html text: '>>'.
	aTOInspector
		renderLink: [ :s | | fr |
			fr := main currentSpace push: self methodClass selecting: #methodSourceBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: self methodSymbol]
		on: html.
	html break.
	(html textArea)
		readonly: true;
		columns: (aTOInspector textAreaColumns: self sourceString);
		rows: (aTOInspector textAreaRows: self sourceString);
		value: self sourceString! !

!MethodReference methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 13:50'!
tODEInspectorFields
	<tODEInspectorFields>
	"force inspector to have standard and basic views"
	^self tODEBasicInspectorFields! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 10:54'!
renderInspectorContentOn: html for: aTOInspector main: main
	"Callback to allow receiver to customize the standard (as opposed to basic) inspector view"
	
	aTOInspector renderStandardContentOn: html main: main! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 10:51'!
renderInspectorTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 11:12'!
tODEBasicInspectorFields
	<tODEBasicInspectorFields>
	| members noMembers |
	members := WriteStream on: Array new.
	noMembers := true.
	self class allInstVarNames
		keysAndValuesDo: [ :index :each | 
			noMembers := false.
			members
				nextPut:
					((TOInspectorKeylessFieldSpec new)
						keyLabel: each asString;
						value: (self instVarAt: index)) ].
	self class isVariable
		ifTrue: [ 
			1 to: self basicSize do: [ :index | 
				noMembers := false.
				members
					nextPut:
						((TOInspectorKeylessFieldSpec new)
							keyLabel: index printString;
							value: (self basicAt: index)) ] ].
	noMembers
		ifTrue: [ members nextPut: (TOInspectorValuelessFieldSpec new valueLabel: self printString) ].
	^ members contents! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 10:50'!
tODEInspectorTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #inspect;
		rendererClass: TOInspector;
		receiver: self;
		label: 'inspect';
		order: 50;
		group: 'basic';
		renderSelector: #renderInspectorTabOn:spec:tOdeMain:! !

Object subclass: #TOInspectorFieldSpec
	instanceVariableNames: 'keyLabel key keySelectedTab valueLabel value valueSelectedTab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspectorFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:26'!
hasKey

	^true! !

!TOInspectorFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:38'!
hasValue

	^true! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:57'!
key
	^ key! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:57'!
key: anObject
	key := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:02'!
keyLabel
	keyLabel ifNil: [^self key printStringLimitedTo: 50].
	^ keyLabel! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
keyLabel: anObject
	keyLabel := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:04'!
keySelectedTab
	keySelectedTab ifNil: [ ^#inspect ].
	^ keySelectedTab! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
keySelectedTab: anObject
	keySelectedTab := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:59'!
value
	^ value! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
value: anObject
	value := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:02'!
valueLabel
	valueLabel ifNil: [^self value printStringLimitedTo: 50].
	^ valueLabel! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
valueLabel: anObject
	valueLabel := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:05'!
valueSelectedTab
	valueSelectedTab ifNil: [ ^#inspect ].
	^ valueSelectedTab! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
valueSelectedTab: anObject
	valueSelectedTab := anObject! !

TOInspectorFieldSpec subclass: #TOInspectorKeylessFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspectorKeylessFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:26'!
hasKey

	^false! !

!TOInspectorKeylessFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:36'!
keyLabel
	^ keyLabel! !

TOInspectorKeylessFieldSpec subclass: #TOInspectorValuelessFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspectorValuelessFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:38'!
hasValue

	^false! !

!TOInspectorValuelessFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:38'!
valueLabel
	^ valueLabel! !

!Collection methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:32'!
tODEInspectorFields
	<tODEInspectorFields>
	| i |
	i := 0.
	^ self asArray
		collect: [ :each | 
			i := i + 1.
			(TOInspectorKeylessFieldSpec new)
				keyLabel: i printString;
				value: each ]! !
